/*
*  Copyright 2021 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#ifndef STRATEGYPARAM_H
#define STRATEGYPARAM_H
#include "dataTypeDef.h"
#include "globalFunc.h"
class StrategyParam {
public:
    StrategyParam();
    StrategyParam(const StrategyParam& orig);
    virtual ~StrategyParam();
    static UINT32 g_RUNTIMES; 		 		
    static string g_GobalID;
    static UINT32 orginalClaNum;
    static UINT32 g_ClaNumNoAxiom; 
    static UINT32 g_AxiomNum; 
    static bool problemDifficult;
    static INT32 R_MAX_TERMNUM; 
    static INT32 SORT_STRATEGY_ALL; 
    static INT32 WORD_NUM_TYPE; 
    static INT32 WEIGHT_TYPE;
    static INT32 STEADY_TYPE; 
    static INT32 SORT_STRATEGY_WORD; 
    static INT32 START_STRATEGY_OTHERTRI; 
    static INT32 SORT_STRATEGY_UNUSECLAUSE; 
    static INT32 SPLIT_FILE_NUM; 
    static INT32 FEATURE_START_CLA; 
    static INT32 NUM_LIT_STARTCLA; 
    static bool ISRESTRICT; 
    static bool ISBACk_FIRST_TRI; 
    static bool ISREVERSE_DEDUCT_S; 
    static INT32 SEL_STARTLit_STRATEGY; 
    static INT32 SEL_STARTLIT_NUMLIT; 
    static INT32 SEL_STARTLIT_STEADY; 
    static bool SEL_STARTLIT_R; 
    static INT32 SEL_ACTLIT_STRATEGY; 
    static INT32 SEL_ACTLIT_STEADY;
    static INT32 SEL_POSLIT_STRATEGY; 
    static INT32 SEL_POSLIT_NUMLIT;
    static INT32 SEL_POSLIT_STEADY; 
    static set<UINT32> CORE_CLAID_SET;
    static UINT32 g_IterTimes;
    static UINT32 g_IterTimesX; 
    static int g_RChgNum; 
    static INT32  unitChoose;  
    static INT32  unitDeduct;  
    static INT32  unitRedunt; 
    static INT32  unitSteady; 
    static INT32  unitFuncLayer;  
    static INT32  candChoose; 
    static INT32  candDeduct;  
    static INT32  candRedunt;
    static INT32  candClause;  
    static INT32  candSteady;  
    static INT32  unitDeductTimes;  
    static INT32  unitDeductTimesUpdate;  
    static INT32  unitReduntTimes;  
    static INT32  unitReduntTimesUpdate;  
    static INT32  candDeductTimes;  
    static INT32  candDeductTimesUpdate;  
    static INT32  candReduntTimes;  
    static INT32  candReduntTimesUpdate;  
    static INT32  candLiteral;  
    static INT32 candLiteralDeductTimes;
    static INT32 candLiteralSteady;
    static INT32 R_MAX_NUM;
    static INT32 R_MAX_NUM_TMP;
    static INT32 R_INIT_MAX_NUM;
    static INT32 R_MAX_NUM_NOPAIR;
    static INT32 R_MAX_FUNCLAYER; 
    static INT32 R_MAX_FUNCLAYER_TMP; 
    static INT32 R_INIT_MAX_FUNCLAYER;
    static UINT8 goalDeepth;
    static INT32 R_Weight;
    static int  midR;
    static int litRundent;
    static INT32 widthDeep;
    static INT32 deductDeep;
    static INT32 deducWidth;
    static INT32 iterTimes;
    static INT32 iterRing;
    static double timeForceLimit;
    static double readPreTime;
    static double firstTimeLimit;
    static double timeLimit;
    static double timeLimitStrategies;
    static INT32 memLimit;
    static vector<UINT32> goalClaId;
    static int singleGoalCount;
    static bool midRJudge;
    static int funcFixDeepth;
    static int funcFixDeepthLit;
    static int funcOrgFixDeepthMax;
    static int funcOrgFixDeepthLessMax;
    static int unitSortRule;
    static int claFuncComp;
    static int unitClaUpdate;
    static bool noUnitRes;
    static bool noUnitSimplify;
    static bool divideTri;
    static bool Rsmall;
    static bool RFsmall;
    static bool RRes;
    static bool delRecord;
    static bool reUseClause;
    static bool genLitClause;
    static int strategyMode;
    static int strategyModeTptp;
    static int noUintCla;
    static int deductMode;
    static bool factorRes;
    static bool eqnRes;
    static bool delPureCla;
    static bool goalCla;
    static bool singleUseUintCla;
    static bool useSaturate;
    static int termRewriting;
    static int termRewritingSize;
    static int deduceDepth;
    static int claReUseTimes;
    static bool useCpUintCla;
    static int claReUseTimesTmp;
    static UINT8 lockType;
    static UINT8 useCombinedSys;
    static UINT8 useCombinedSysMethod;
    static UINT8 combinedRMode;
    static UINT8 equalityUsedFrq;
    static UINT8 preprocess;
    static bool useRandrom;
    static bool termReRedund;
    static double firstRunTime;
    static bool orForCompition;
    static int problemDiv;
    static int cseRunMode;
    static bool findStr;
    static double distriTime;
    static UINT64 compOutputId;
    static clock_t start;
    static void IniStrategy();
    static void IniFileAndPathInfo(char*str, INT32 StartId);
private:

};

#endif /* STRATEGYPARAM_H */

