/*
*  Copyright 2020 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#include "Subsumption.h"

Subsumption::Subsumption() {
}

Subsumption::Subsumption(const Subsumption& orig) {
}

Subsumption::~Subsumption() {
}

bool Subsumption::CheckTautology(vector<string>& vectLit) {
    vector<string>::iterator it;
    for (it = vectLit.begin(); it<--vectLit.end(); ++it) {
        for (vector<string>::iterator itB = it + 1; itB < vectLit.end(); ++itB) {
            string&strLitA = *it;
            string & strLitB = *itB;
            if ((strLitA[0] == '~' && strLitB[0] == '~') || strLitA[0] != '~' && strLitB[0] != '~')
                return false;
            string s1 = strLitA[0] == '~' ? strLitA.substr(1) : strLitA;
            string s2 = strLitB[0] == '~' ? strLitB.substr(1) : strLitB;

            if (s1 == s2)
                return true;
        }
    }
    return false;
}
